/*
	Project:	Einstein NS Runtime
	File:		Display Params.f
*/

knownGlobalFunctions.GetAllRawDisplayParams := 0;
knownGlobalFunctions.GetOrientation := 0;

DefConst('kSetDisplayParamsFn,
func()
begin
	local theDisplayParams := GetAllRawDisplayParams();
	local systemGestalt := Gestalt(0x1000003);
	local thePortraitWidth := systemGestalt.screenwidth;
	local thePortraitHeight := systemGestalt.screenheight;
	local theOrientation := GetOrientation();
	if (theOrientation = 1) or (theOrientation = 3) then
	begin
		local theActualHeight := thePortraitWidth;
		thePortraitWidth := thePortraitHeight;
		thePortraitHeight := theActualHeight;
	end;
	local theXDelta := thePortraitWidth - theDisplayParams[0].scrWidth;
	local theYDelta := thePortraitHeight - theDisplayParams[0].scrHeight;

	if (theXDelta <> 0) or (theYDelta <> 0) then
	begin
		local myDisplayParams := [];
		foreach originalParam in theDisplayParams do
		begin
			local param := Clone(originalParam);
			if (param.orientation = 0) or (param.orientation = 2) then
			begin
				// Portrait.
				param.scrWidth := param.scrWidth + theXDelta;
				param.scrHeight := param.scrHeight + theYDelta;
				param.appAreaWidth := param.appAreaWidth + theXDelta;
				param.appAreaHeight := param.appAreaHeight + theYDelta;
				param.rootBounds := Clone(param.rootBounds);
				param.rootBounds.right := param.rootBounds.right + theXDelta;
				param.rootBounds.bottom := param.rootBounds.bottom + theYDelta;
				param.appAreaBounds := Clone(param.appAreaBounds);
				param.appAreaBounds.right := param.appAreaBounds.right + theXDelta;
				param.appAreaBounds.bottom := param.appAreaBounds.bottom + theYDelta;
				if (param.buttonBarPosition = 'bottom) then
				begin
					param.buttonBarBounds := Clone(param.buttonBarBounds);
					param.buttonBarBounds.top := param.buttonBarBounds.top + theYDelta;
					param.buttonBarBounds.bottom := param.buttonBarBounds.bottom + theYDelta;
					param.buttonBarBounds.right := param.buttonBarBounds.right + theXDelta;
				end;
			end else begin
				// Landscape.
				param.scrWidth := param.scrWidth + theYDelta;
				param.scrHeight := param.scrHeight + theXDelta;
				param.appAreaWidth := param.appAreaWidth + theYDelta;
				param.appAreaHeight := param.appAreaHeight + theXDelta;
				param.rootBounds := Clone(param.rootBounds);
				param.rootBounds.right := param.rootBounds.right + theYDelta;
				param.rootBounds.bottom := param.rootBounds.bottom + theXDelta;
				param.appAreaBounds := Clone(param.appAreaBounds);
				param.appAreaBounds.right := param.appAreaBounds.right + theXDelta;
				param.appAreaBounds.bottom := param.appAreaBounds.bottom + theYDelta;
				if (param.buttonBarPosition = 'right) then
				begin
					param.buttonBarBounds := Clone(param.buttonBarBounds);
					param.buttonBarBounds.left := param.buttonBarBounds.left + theYDelta;
					param.buttonBarBounds.right := param.buttonBarBounds.right + theYDelta;
					param.buttonBarBounds.bottom := param.buttonBarBounds.bottom + theXDelta;
				end;
			end;
			AddArraySlot(myDisplayParams, param);
		end;
		DefGlobalVar('AllRawDisplayParams, myDisplayParams);
		
		displayParams := myDisplayParams[theOrientation];
		// Cheat to prevent the little dialog to be seen.
		GetRoot():LockScreen(true);
		GetRoot():FixupDisplay();
		GetRoot():LockScreen(nil);
	end;
end);