// ==============================
// File:			TNSRuntimeEventHandler.h
// Project:			Einstein
//
// Copyright 2003-2007 by Paul Guyot (pguyot@kallisys.net).
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
// ==============================
// $Id$
// ==============================

#ifndef _TNSRUNTIMEEVENTHANDLER_H
#define _TNSRUNTIMEEVENTHANDLER_H

#include "NSandDDKIncludes.h"
#include <AEventHandler.h>

///
/// Class for Einstein NS Runtime events handler.
///
/// \author Paul Guyot <pguyot@kallisys.net>
/// \version $Revision: 113 $
///
/// \test	aucun test dfini.
///
class TNSRuntimeEventHandler
	:
		public TAEventHandler
{
public:
	///
	/// Default constructor.
	///
	TNSRuntimeEventHandler( void );

	///
	/// Handler method.
	///
	/// \param inCopy		objet  copier
	///
	virtual	void	AEHandlerProc( TUMsgToken* token, ULong* size, TAEvent* event );
};

#endif
		// _TNSRUNTIMEEVENTHANDLER_H

// ===================================================================== //
// The algorithm for finding the longest path in a graph is NP-complete. //
// For you systems people, that means it's *real slow*.                  //
//                 -- Bart Miller                                        //
// ===================================================================== //
