/*
	File:		Install & Remove.f
	Project:	Keyboards
	Written by:	Paul Guyot
	Copyright:	(c) 1997-2006 by Paul Guyot.
				All rights reserved worldwide.
*/

SetPartFrameSlot('Text, kExtrasTextStr );
SetPartFrameSlot('TapAction, func()
	begin
		GetRoot():Notify( 3, kExtrasTextStr, kAboutStr );
		return GetUserConfig('ExtraAlwaysClose);
	end;
);

installScript := func ( partFrame, autoFrame )
begin
	// We add every keyboards
	GetGlobalVar('international).(EnsureInternal('keyboards)) := clone(GetGlobalVar('international).keyboards);

	foreach kbd in kKeyboards do
	begin
		AddArraySlot(GetGlobalVar('international).keyboards, EnsureInternal(kbd));
		if (GetUserConfig('Keyboard)) then
		if (StrEqual(kbd.title, GetUserConfig('Keyboard))) then
		begin
			// install keyboard as the current keyboard
			GetGlobalVar('international).(EnsureInternal('keyboard)) := EnsureInternal(kbd);
		end;
	end; // foreach kbd in kKeyboards
end;

removeScript := func ( removeFrame )
begin
	local int i;
	local theKbds := GetGlobalVar('international).keyboards;
	for i := length(theKbds) - 1 to 0 by -1 do
	begin
		if theKbds[i].owner = kAppSymbol then
			ArrayRemoveCount(theKbds, i, 1);
	end;
	
	if Length(theKbds) = Length( GetGlobalVar('international)._proto.keyboards ) then
		RemoveSlot(GetGlobalVar('international), 'keyboards);
	
	if GetGlobalVar('international).keyboard.owner = kAppSymbol then
	begin
		// oops. the current keyboard belongs to me.
		GetGlobalVar('international).(EnsureInternal('keyboard)) := theKbds[0];
	end;
end;