// =========== Header ===========
// File:				NSandDDKIncludes.h
// Project:				(Library)
// Written by:			Paul Guyot (pguyot@kallisys.net)
//
// Created on:			05/01/2001
// Internal version:	1
//
// Copyright:			 2001 by Paul Guyot.
// 						All rights reserved worldwide.
// ===========

// =========== Change History ===========
// 05/01/2001	v1	[PG]	Creation of the file
// ===========

#ifndef __NSANDDDKINCLUDES__
#define __NSANDDDKINCLUDES__

class TSendSystemEvent;	// bug in SystemEvents.h

#include "UserGlobals_m.h"
#include "UserTasks_m.h"
#include "Objects_m.h"

#ifndef __NEWTON_H
	#include <Newton.h>
#endif

// The NewtonErrors define kNoMemory once again.
#undef kNoMemory
#include <NewtonErrors.h>

#ifndef WITH_LOCKED_BINARY

extern Ptr		LockedBinaryPtr(RefArg obj);
extern void		UnlockRefArg(RefArg obj);

#define WITH_LOCKED_BINARY(obj, ptr_var)        \
        unwind_protect {        \
            void* ptr_var = LockedBinaryPtr(obj);

#define END_WITH_LOCKED_BINARY(obj)  \
        }       \
        on_unwind {				\
            UnlockRefArg(obj);     \
        }       \
        end_unwind;
#endif

//____________________________________________________________________
// Object Class Functions

extern	Ref		ClassOf(RefArg obj);
extern	Boolean IsArray(RefArg ref);
extern	Boolean IsBinary(RefArg ref);
extern	Boolean IsFrame(RefArg ref);
extern	Boolean IsFunction(RefArg ref);								

extern	Boolean IsNumber(RefArg ref);
extern	Boolean IsReadOnly(RefArg obj);
extern	Boolean	IsReal(RefArg ref);
extern	Boolean	IsString(RefArg ref);
extern	Boolean	IsSymbol(RefArg obj);

extern	void	SetClass(RefArg obj, RefArg theClass);

extern	Boolean IsMagicPtr(RefArg r);    
extern	Boolean IsRealPtr(RefArg r);   

#endif
		// __NSANDDDKINCLUDES__

// ======================================== //
// Ask not for whom the <CONTROL-G> tolls. //
// ======================================== //