// =========== Header ===========
// File:				UserGlobals_m.h
// Project:				ATA Support for Newton OS, Waba
// Written by:			Paul Guyot (pguyot@kallisys.net)
//
// Created on:			06/28/2000
// Internal version:	1
//
// Copyright:			 2000 by Paul Guyot.
// 						All rights reserved worldwide.
// ===========

// =========== Change History ===========
// 06/28/2000	v1	[PG]	Creation of the file
// ===========

#ifndef __USERGLOBALS_H
#define __USERGLOBALS_H

// From UserGlobals.h, just what is required
#ifndef __NEWTON_H
#include "Newton.h"
#endif

#ifndef	__KERNELTYPES_H
#ifndef	__KERNELTYPES__	// obsolete
#include 	"KernelTypes.h"
#endif
#endif

#ifndef	__LONGTIME_H
#ifndef	__LongTime__	// obsolete
#include	"LongTime.h"
#endif
#endif

#ifndef __NEWTCONFIG_H
#include	"NewtConfig.h"	// because they used to be defined in this file
#endif

extern "C" ULong GetPortSWI(ULong what);
extern "C" long GenericSWI(...);
extern "C" long GenericWithReturnSWI(ULong p1, ULong p2, ULong p3, ULong p4, ULong* rp1, ULong* rp2, ULong* rp3);
extern "C" long SemaphoreOpGlue(ULong ObjectId, ULong OpListId, ULong flags);
extern "C" long PortSendSWI(ULong ObjectId, ULong msgId, ULong replyId, ULong msgType, ULong flags);
extern "C" long PortReceiveSWI(ULong ObjectId, ULong msgId, ULong msgFilter, ULong flags, ULong* senderMsgId, ULong* replyMemId, ULong* returnMsgType, ULong* signature);
extern "C" long PortResetFilterSWI(ULong ObjectId, ULong msgId, ULong msgFilter);

extern "C" long SMemSetBufferSWI(ULong ObjectId, void* buffer, ULong size, ULong permissions);
extern "C" long SMemGetSizeSWI(ULong ObjectId, ULong* returnSize, void** returnBuffer, ULong* refConPtr);
extern "C" long SMemCopyToSharedSWI(ULong ObjectId, void* buffer, ULong size, ULong offset, ULong sendersMsgId, ULong signature);
extern "C" long SMemCopyFromSharedSWI(ULong ObjectId, void* buffer, ULong size, ULong offset, ULong sendersMsgId, ULong signature, ULong* returnSize);
extern "C" long MonitorDispatchSWI(ULong ObjectId, long selector, void* userObject);
extern "C" long MonitorExitSWI(long monitorResult, void* continuationPC);
extern "C" long MonitorThrowSWI(char *, void *, void *);
extern "C" long MonitorFlushSWI(ULong ObjectId);
extern "C" long SMemMsgSetTimerParmsSWI(ULong ObjectId, ULong timeout, ULong timeLow, ULong timeHigh);
extern "C" long SMemMsgSetMsgAvailPortSWI(ULong ObjectId, ULong availPort);
extern "C" long SMemMsgGetSenderTaskIdSWI(ULong ObjectId, void* senderTaskId);
extern "C" long SMemMsgSetUserRefConSWI(ULong ObjectId, ULong refCon);
extern "C" long SMemMsgGetUserRefConSWI(ULong ObjectId, ULong* refConPtr);
extern "C" long SMemMsgMsgDoneSWI(ULong ObjectId, long result, ULong signature);
extern "C" long SMemMsgCheckForDoneSWI(ULong ObjectId, ULong flags, ULong* sentById, ULong* replymemId, ULong* msgType, ULong* signature);

#endif
		// __USERGLOBALS_H

// ====================================================== //
// Is a computer language with goto's totally Wirth-less? //
// ====================================================== //