// ==============================
// File:			TToolkitPrototypes.h
// Project:			Einstein
//
// Copyright 2003-2022 by Paul Guyot and Matthias Melcher.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
// ==============================
// $Id$
// ==============================

#ifndef _T_TOOLKIT_PROTOTYPE_H
#define _T_TOOLKIT_PROTOTYPE_H

namespace TToolkitPrototype {

extern const char* NewtonDefs21;
extern const char* BytecodeDefs;
extern const char* ToolkitDefs;
extern const char* DefaultPackage;
extern const char* ToolkitLaunch;
extern const char* ToolkitDone;

}

typedef struct {
	int err;
	const char* text;
} NewtErrorText;
extern NewtErrorText gNewtErrorTextList[];

#endif
// _T_TOOLKIT_PROTOTYPE_H

// ======================================================================= //
// Newton Toolkit
//
// A development environment created by Apple for writing NewtonScript programs
// for Newton OS. A prototype for Newton Toolkit called EtchASketch was written
// using Macintosh Common Lisp. Also referred to as NTK.
//
//   -- Newton Glossary
// ======================================================================= //
